// Program associated with the paper entitled "N
// "Nonlinear bounded-error state estimation of continuous-time systems"
// submitted to Automatica
// The algorithms can be found in the file 'algo.cpp'

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "fiche.h"
#include "box.h"
#include "repere.h"
#include "algo.cpp"
#include "iboolean.cpp"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
box P0(2,true);
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner) {}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClick(TObject *Sender)
{   ButtonStateEstimation->Visible=true;
    ButtonSimulation->Visible=true;
    Memo1->Visible=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonStateBoundClick(TObject *Sender)
// From measurements
{   ButtonInitClick(Sender);
    clock_t start, end;
    start = clock();
    repere R(this,Inf(P0[1]),Sup(P0[1]),Inf(P0[2]),Sup(P0[2]));
    R.DrawBox(P0,clWhite,clWhite,bsSolid);
    StateBound(R);
    end = clock();
    Memo1->Text=Memo1->Text+ "---  Computing time = " +((end-start)/CLK_TCK);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonSimulationClick(TObject *Sender)
{   ButtonInitClick(Sender);
    clock_t start, end;
    start = clock();
    repere R(this,Inf(P0[1]),Sup(P0[1]),Inf(P0[2]),Sup(P0[2]));
    R.DrawBox(P0,clWhite,clWhite,bsSolid);
    Simulation(R);
    end = clock();
    Memo1->Text=Memo1->Text+ "--- Computing time = " +((end-start)/CLK_TCK);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonInitClick(TObject *Sender)
{   Memo1->Visible=false;
    ButtonStateEstimation->Visible=false;
    ButtonSimulation->Visible=false;
    P0[1]=interval(0,100);	P0[2]=interval(0,200);
}
//---------------------------------------------------------------------------


